/*-------------------------- Parallax Standard H_File ----------------------------
   
   H_File   : in_api.h
   
   Scope    : Windows

   Purpose  : Header file for the API

   
--------------------------------------------------------------------------------
          Copyright (c)1995 Parallax Software , All rights reserved.            
------------------------------------------------------------------------------*/

#ifndef  INC_INAPI
#define  INC_INAPI


/* Make sure that FAR is defined */
#ifndef FAR
#ifdef  IM_MSWIN
#define FAR far
#endif
#endif

/* Make sure that PASCAL is defined */
#ifndef PASCAL
#ifdef  IM_MSWIN
#define PASCAL  pascal
#endif
#endif


/* All entry-points are to be exported */
#ifdef IM_MSWIN_31

#ifndef API_EPOINT
#define API_EPOINT        _export FAR PASCAL
#endif

typedef int               SHORT;
typedef unsigned          USHORT;

#elif IM_MSWIN_95

#ifndef API_EPOINT
#define API_EPOINT        FAR PASCAL
#endif

typedef short             SHORT;
typedef unsigned short    USHORT;

#else

#ifndef API_EPOINT
#define API_EPOINT
#endif

typedef short             SHORT;
typedef unsigned short    USHORT;

#endif  /*  IM_MSWIN_31  */


/* Portable data-types */
#ifndef INC_STDTYPES
  typedef char FAR       *CHARPTR;
  typedef int FAR        *INTPTR;
  typedef unsigned FAR   *UINTPTR;
  typedef double          DOUBLE;
  typedef DOUBLE FAR     *DOUBLEPTR;
#ifndef LONG  
  typedef long            LONG;
#endif  
  typedef long FAR       *LONGPTR;
  typedef unsigned long   ULONG;
  typedef ULONG FAR      *ULONGPTR;
  typedef void FAR       *STDPTR;
#endif
typedef SHORT  IN_BOOL, FAR *IN_BOOLPTR;
typedef SHORT   FAR  *SHORTPTR;
typedef USHORT  FAR  *USHORTPTR;



/* Other include files */
#ifndef INC_INAPIDEF
#include <inapidef.h>
#endif
#ifndef INC_INAPIERR
#include <inapierr.h>
#endif
#ifndef INC_INAPIOBJ
#include <inapiobj.h>
#endif



/* Define the various object types within Eroica */
typedef unsigned long  IN_OBJECT,   FAR *IN_OBJECT_PTR;
typedef IN_OBJECT      IN_DOCWIN,   FAR *IN_DOCWIN_PTR;
typedef IN_OBJECT      IN_DOCUMENT, FAR *IN_DOCUMENT_PTR;
typedef IN_OBJECT      IN_PAGE,     FAR *IN_PAGE_PTR;
typedef IN_OBJECT      IN_LAYER,    FAR *IN_LAYER_PTR;
typedef IN_OBJECT      IN_VECTOR,   FAR *IN_VECTOR_PTR; /* Can't be addressed on their own, need a layerID too */

/* Structure for GetLayerInfo */
typedef struct tagIN_LAYER_INFO {
  SHORT        layerType; 
  LONG         colorCount;
  LONG         sizePixelX;
  LONG         sizePixelY;
  SHORT        resolutionX;
  SHORT        resolutionY;
  SHORT        tileCount;
  LONG         tileSizeX;
  LONG         tileSizeY;
  LONG         entityCount;
  LONG         selectedCount;
  SHORT        formatID;
  SHORT        subPageNum;
  char         headerString[100];
  char         dataString[100];
  char         fileName[256];
} IN_LAYER_INFO, FAR *IN_LAYER_INFO_PTR;



/* Misc macros */
#define IN_GetNumberDocumentWindows(pCount)                               IN_GetDocumentWindows(0, (pCount), NULL)
#define IN_PlaceLineHotspot(docwinID,hotspotID,unitType,x1,y1,x2,y2)      IN_PlaceHotspot((docwinID), IN_TOOL_LINE, (hotspotID), (unitType), (x1), (y1), (x2), (y2) )
#define IN_PlaceBoxHotspot(docwinID,hotspotID,unitType,x1,y1,x2,y2)       IN_PlaceHotspot((docwinID), IN_TOOL_BOX, (hotspotID), (unitType), (x1), (y1), (x2), (y2))
#define IN_PlaceCircleHotspot(docwinID,hotspotID,unitType,x,y,r)          IN_PlaceHotspot((docwinID), IN_TOOL_CIRCLE, (hotspotID), (unitType), (x), (y), (r), 0)
#define IN_PlaceEllipseHotspot(docwinID,hotspotID,unitType,x,y,xr,yr)     IN_PlaceHotspot((docwinID), IN_TOOL_ELLIPSE, (hotspotID), (unitType), (x), (y), (xr), (yr))
#define IN_PlaceIconHotspot(docwinID,hotspotID,unitType,x,y,iconIndex)    IN_PlaceHotspot((docwinID), IN_TOOL_ICON, (hotspotID), (unitType), (x), (y), (iconIndex), 0)
#define IN_DeleteLayer( layerID )                                         IN_DeleteObject( layerID )



/* System Properties */
int  API_EPOINT IN_GetHighlightBoxColor( USHORTPTR pColor);
int  API_EPOINT IN_GetHotspotPromptDataFlag( IN_BOOLPTR pOnOff);
int  API_EPOINT IN_GetReadOnlyModsFlag( IN_BOOLPTR pOnOff);
int  API_EPOINT IN_IsDetailWindowVisible( IN_BOOLPTR pOnOff);
int  API_EPOINT IN_IsContentsVisible( IN_BOOLPTR pOnOff);
int  API_EPOINT IN_IsReferenceWindowVisible( IN_BOOLPTR pOnOff);
int  API_EPOINT IN_IsToolBarVisible( IN_BOOLPTR pOnOff);
int  API_EPOINT IN_IsRibbonBarVisible( IN_BOOLPTR pOnOff);
int  API_EPOINT IN_IsStatusBarVisible( IN_BOOLPTR pOnOff);
int  API_EPOINT IN_IsMenuBarVisible( IN_BOOLPTR pOnOff);
int  API_EPOINT IN_GetButtonStatus( SHORT buttonID, USHORTPTR pStatus );
int  API_EPOINT IN_GetMenuStatus( SHORT menuID, USHORTPTR pStatus );
int  API_EPOINT IN_GetUIConfiguration( SHORT cfgNumber, IN_BOOLPTR pState );
int  API_EPOINT IN_SetUIConfiguration( SHORT cfgNumber, IN_BOOL state );
int  API_EPOINT IN_SetSymbol( CHARPTR fileName );
int  API_EPOINT IN_ShowDetailWindow( IN_BOOL bOnOff );
int  API_EPOINT IN_ShowContents( IN_BOOL bOnOff );
int  API_EPOINT IN_ShowReferenceWindow( IN_BOOL bOnOff );
int  API_EPOINT IN_ShowToolBar( IN_BOOL bOnOff );
int  API_EPOINT IN_ShowMenuBar( IN_BOOL bOnOff );
int  API_EPOINT IN_ShowStatusBar( IN_BOOL pOnOff );
int  API_EPOINT IN_ShowRibbonBar( IN_BOOL bOnOff );
int  API_EPOINT IN_SetButtonStatus( SHORT buttonID, SHORT status );
int  API_EPOINT IN_SetMenuStatus( SHORT menuID, SHORT status );
int  API_EPOINT IN_SetReadOnlyModsFlag( IN_BOOL bOnOff );
int  API_EPOINT IN_SetOverwriteRaster( IN_BOOL bOnOff );
int  API_EPOINT IN_SetRemoveMergedLayers( IN_BOOL bOnOff );
int  API_EPOINT IN_SetDefaultLayerFormat( USHORT layerType, SHORT formatID );
int  API_EPOINT IN_SetCFGFilename( CHARPTR fileName );
int  API_EPOINT IN_GetCFGFilename( SHORT maxLen, CHARPTR fileName );
int  API_EPOINT IN_GetAsciiTemplateFilename( SHORT maxLen, CHARPTR fileName );
int  API_EPOINT IN_SetAsciiTemplateFilename( CHARPTR fileName );
int  API_EPOINT IN_GetSymbolDirectory( SHORT maxLen, CHARPTR path );
int  API_EPOINT IN_SetSymbolDirectory( CHARPTR path );
int  API_EPOINT IN_GetDocumentDirectory( SHORT maxLen, CHARPTR path );
int  API_EPOINT IN_SetDocumentDirectory( CHARPTR path );
int  API_EPOINT IN_GetDocumentID( IN_OBJECT objectID, IN_OBJECT_PTR pDocumentID);
int  API_EPOINT IN_GetScanParameter( SHORT parmID, SHORT maxLen, CHARPTR pValue );
int  API_EPOINT IN_SetScanParameter( SHORT parmID, CHARPTR pValue );
int  API_EPOINT IN_GetXRefPath( SHORT formatID, SHORT maxLen, CHARPTR pValue );
int  API_EPOINT IN_SetXRefPath( SHORT formatID, CHARPTR pValue );
int  API_EPOINT IN_SetProductSwitch( USHORT uSwitchID, IN_BOOL bValue );
int  API_EPOINT IN_GetProductSwitch( USHORT uSwitchID, IN_BOOLPTR pbValue );


/* Object Properties */
int  API_EPOINT IN_GetLayerColor( IN_DOCWIN docwinID, IN_LAYER layerID, ULONGPTR pColor);
int  API_EPOINT IN_GetViewHairlines( IN_DOCWIN docwinID, IN_BOOLPTR pOnOff );
int  API_EPOINT IN_GetViewWireframes( IN_DOCWIN docwinID, IN_BOOLPTR pOnOff );
int  API_EPOINT IN_GetViewMonochrome( IN_DOCWIN docwinID, IN_BOOLPTR pOnOff );
int  API_EPOINT IN_GetLayerFormat( IN_LAYER layerID, USHORTPTR pFormat );
int  API_EPOINT IN_GetOverwriteRaster( IN_BOOLPTR pOnOff);
int  API_EPOINT IN_GetRemoveMergedLayers( IN_BOOLPTR pOnOff );
int  API_EPOINT IN_GetTool( IN_DOCWIN docwinID, USHORTPTR pToolType);
int  API_EPOINT IN_GetState( IN_OBJECT objectID, IN_BOOL checkDescendents, USHORTPTR pStatus );
int  API_EPOINT IN_SetRasterInfoString( IN_LAYER layerID, CHARPTR pInfo );
int  API_EPOINT IN_SetLayerColor( IN_DOCWIN docwinID, IN_LAYER layerID, ULONG color );
int  API_EPOINT IN_SetViewHairlines( IN_DOCWIN docwinID, IN_BOOL bOnOff );
int  API_EPOINT IN_SetViewWireframes( IN_DOCWIN docwinID, IN_BOOL bOnOff );
int  API_EPOINT IN_SetViewMonochrome( IN_DOCWIN docwinID, IN_BOOL bOnOff );
int  API_EPOINT IN_SetTool( IN_DOCWIN docwinID, ULONG toolType );
int  API_EPOINT IN_SetState( IN_OBJECT objectID, SHORT state );
int  API_EPOINT IN_SetZoom( IN_DOCWIN docwinID, USHORT zoomLevel );
int  API_EPOINT IN_SetScrollView( IN_DOCWIN docwinID, ULONG scrollMode );
int  API_EPOINT IN_SetScrollStep( IN_DOCWIN docwinID, DOUBLE scrollStep );
int  API_EPOINT IN_GetFilename( IN_OBJECT objectID, SHORT maxLen, CHARPTR fileName );
int  API_EPOINT IN_SetFilename( IN_OBJECT objectID, CHARPTR fileName );
int  API_EPOINT IN_GetTitle( IN_OBJECT objectID, SHORT maxLen, CHARPTR title );
int  API_EPOINT IN_SetTitle( IN_OBJECT objectID, CHARPTR title );



/* Communication routines */
int  API_EPOINT  IN_Startup( HINSTANCE hInst );
int  API_EPOINT  IN_Shutdown( void );
int  API_EPOINT  IN_GetErrorMessage( SHORT error, SHORT bufferSize, CHARPTR pBuffer );



/* Notification routines */
BOOL API_EPOINT  IN_MessageHook( HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam, LRESULT FAR *lpResult );
int  API_EPOINT  IN_SetAdviseHWnd( HWND hWnd );
int  API_EPOINT  IN_InterceptMenuAction( USHORT menuID, IN_BOOL state );
int  API_EPOINT  IN_ApproveMenuAction( USHORT menuID ) ;
int  API_EPOINT  IN_RegisterQuery( SHORT queryID, IN_OBJECT objectID, ULONG callback );
int  API_EPOINT  IN_RegisterNotify( SHORT notifyID, IN_OBJECT objectID, ULONG callback );
int  API_EPOINT  IN_UnregisterNotify( SHORT notifyID, IN_OBJECT objectID, ULONG callback );
int  API_EPOINT  IN_UnregisterQuery( SHORT queryID, IN_OBJECT objectID, ULONG callback );



/* Helper routines - Do not call these directly */
int API_EPOINT  IN_InterceptSpecialMenuAction( USHORT menuID, IN_BOOL state, HWND hCallbackWnd ); 
int API_EPOINT  IN_SetProperty( IN_OBJECT objectID, ULONG propertyID, ULONG subID, ULONG value );
int API_EPOINT  IN_GetProperty( IN_OBJECT objectID, ULONG propertyID, ULONG subID, STDPTR value );
int API_EPOINT  IN_SetPropertyDouble( IN_OBJECT objectID, ULONG propertyID, ULONG subID, DOUBLE value );
int API_EPOINT  IN_SetPropertyString( IN_OBJECT objectID, ULONG propertyID, ULONG subID, CHARPTR pValue );
int API_EPOINT  IN_GetPropertyString( IN_OBJECT objectID, ULONG propertyID, ULONG subID, SHORT maxSize, CHARPTR pValue );
int API_EPOINT  IN_RegisterAdvise( SHORT notifyID, IN_OBJECT objectID, ULONG callback );
int API_EPOINT  IN_UnregisterAdvise( SHORT notifyID, IN_OBJECT objectID, ULONG callback );



/* System Operations */
int API_EPOINT  IN_RefreshPrintOptions( void );
int API_EPOINT  IN_GetPrinterName( USHORT printerNameLen, CHARPTR printerName );
int API_EPOINT  IN_GetPrinterNames( USHORT printerNameLen, CHARPTR printerNames );
int API_EPOINT  IN_SetPrinterName( CHARPTR printerName, CHARPTR driverName, CHARPTR deviceName );
int API_EPOINT  IN_ActivateFrame( void );
int API_EPOINT  IN_EnableSystemMenuCommands( IN_DOCWIN docwinID, long commands );
int API_EPOINT  IN_CreateDocumentWindow( CHARPTR title, IN_DOCWIN_PTR pNewDocwinID );
int API_EPOINT  IN_GetActiveDocumentWindow( IN_DOCWIN_PTR pDocwin );
int API_EPOINT  IN_GetDocumentWindows( SHORT maxDocwins, SHORTPTR pDocwinCount, IN_DOCWIN_PTR pDocwinIDs );
int API_EPOINT  IN_GetDocwinIDFromHWnd( HWND hWnd, IN_DOCWIN_PTR pDocwinID );
int API_EPOINT  IN_GetDirtyDocumentWindows( SHORT maxDocwins, SHORTPTR pDocwinCount, IN_DOCWIN_PTR pDocwinIDs );
int API_EPOINT  IN_GetFrameHWnd( HWND FAR *pHWnd );
int API_EPOINT  IN_GetHWndFromDocwinID( IN_DOCWIN docwinID, HWND FAR *pHWnd );
int API_EPOINT  IN_OpenDocumentWindow( SHORT location, CHARPTR szFilename, SHORT maxDocwins, SHORTPTR pDocwinCount, IN_DOCWIN_PTR pDocwinIDs );
int API_EPOINT  IN_CloseAllDocumentWindows( IN_BOOL promptForSave );
int API_EPOINT  IN_Terminate( void );
int API_EPOINT  IN_EndFrame( void );
int API_EPOINT  IN_GetIMVersion( SHORTPTR major, SHORTPTR minor, SHORTPTR build, SHORT maxLen, CHARPTR pVersion );
int API_EPOINT  IN_GetProduct( USHORT maxCount, INTPTR pProductID, UINTPTR pProductCount, INTPTR pProductIDs );
int API_EPOINT  IN_SetProduct( USHORT productID );
int API_EPOINT  IN_GetProductIDName( USHORT productID, SHORT bufSize, CHARPTR szProductName );
int API_EPOINT  IN_SetActiveDocumentWindow( IN_DOCWIN docwinID );
int API_EPOINT  IN_ShowFrame( SHORT mode );
/* int API_EPOINT  IN_FlushWorklist( IN_BOOL saveCheck ); */ /* obsolete, use IN_CloseAllDocwins */
int API_EPOINT  IN_GetObjectType( IN_OBJECT objectID, SHORTPTR pType );
int API_EPOINT  IN_ReplaceDocument( IN_DOCWIN docwinID, IN_BOOL savePrompt, SHORT location, CHARPTR fileName, IN_DOCWIN_PTR newDocwinID );
int API_EPOINT  IN_GetSystemToolAttribute( SHORT toolID, SHORT attributeID, SHORT valueLen, CHARPTR value );
int API_EPOINT  IN_SetSystemToolAttribute( SHORT toolID, SHORT attributeID, CHARPTR value, USHORT units );
int API_EPOINT  IN_SetBannerPrintOptions( USHORT bannerLocation, DOUBLE fontSize, USHORT units, CHARPTR fontName, CHARPTR bannerText, IN_BOOL writeToINI );
int API_EPOINT  IN_SetHotspotPromptDataFlag( IN_BOOL flagState );
int API_EPOINT  IN_SetHighlightBoxColor( ULONG color);
int API_EPOINT  IN_SetPrintOptions( USHORT merge, USHORT banner, USHORT center, USHORT dither, USHORT bilevel, USHORT scaleType, USHORT mode, IN_BOOL writeToINI );



/* Document Window Operations */
int API_EPOINT  IN_ArrangeDocumentWindows( SHORT arrangement );
int API_EPOINT  IN_CloseDocumentWindow( IN_DOCWIN docwinID, IN_BOOL saveCheck );
int API_EPOINT  IN_ShowTextMatch( IN_DOCWIN docwinID, IN_BOOL state );
int API_EPOINT  IN_Deskew( IN_OBJECT objectID, DOUBLE angle, IN_DOCWIN_PTR pNewDocwinID );
int API_EPOINT  IN_Despeckle( IN_OBJECT objectID, SHORT speckleSize, IN_DOCWIN_PTR pNewDocwinID );
int API_EPOINT  IN_FaxDocumentWindow( IN_DOCWIN docwinID, CHARPTR phoneNumber, SHORT pageRange, SHORT firstPage, SHORT lastPage, SHORT mode, SHORT resolution, SHORT tile, SHORT scale, SHORT orientation, SHORT maxLen, CHARPTR fileName );
int API_EPOINT  IN_FindTextMatch( IN_DOCWIN docwinID, CHARPTR text, SHORT flags, SHORT direction );
int API_EPOINT  IN_GetDeskewLimits( IN_OBJECT objectID, DOUBLEPTR pMaxAngle );
int API_EPOINT  IN_GetDirtyPageIDs( IN_DOCWIN pDocwinID, SHORT maxPageIDs, SHORTPTR pPageCount, IN_PAGE_PTR pPageIDs );
int API_EPOINT  IN_GetDocumentWindowRefresh( IN_DOCWIN docwinID, SHORTPTR pRefreshFlag );
int API_EPOINT  IN_GuessDeskewAngle( IN_OBJECT objectID, DOUBLEPTR pSkewAngle );
int API_EPOINT  IN_Merge( IN_OBJECT objectID, SHORT mergeType, SHORT xResolution, SHORT yResolution, IN_BOOL bColor, IN_BOOL bDither, IN_OBJECT_PTR pNewDocwinID );
int API_EPOINT  IN_MoveDocumentWindow( IN_DOCWIN docwinID, SHORT x1, SHORT y1, SHORT dx, SHORT dy );
int API_EPOINT  IN_MoveIMWindow( SHORT x1, SHORT y1, SHORT dx, SHORT dy );
int API_EPOINT  IN_HandleExternalDocumentWindow( IN_DOCWIN docwinID, int initialMode );
int API_EPOINT  IN_SetExtDocumentWindowMode( IN_DOCWIN docwinID, int mode );
int API_EPOINT  IN_GetExtDocumentWindowMode( IN_DOCWIN docwinID, INTPTR pMode );
int API_EPOINT  IN_ResetExternalDocumentWindowSize( IN_DOCWIN docwinID );
int API_EPOINT  IN_ProcessExternalWindowMessage( HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam );
int API_EPOINT  IN_OCRRegion( IN_DOCWIN docwinID, CHARPTR fileName, SHORT formatID, SHORT unitType, LONG x1, LONG y1, LONG x2, LONG y2 );
int API_EPOINT  IN_OpenExternalDocumentWindow( IN_DOCWIN docwinID, SHORT location, CHARPTR szFilename, CHARPTR title, USHORT flags );
int API_EPOINT  IN_PrintAreaDocumentWindow( IN_DOCWIN docwinID, USHORT unitType, long x1, long y1, long x2, long y2, IN_BOOL printBanner );
int API_EPOINT  IN_PrintDocumentWindow( IN_DOCWIN docwinID, SHORT inprnType, SHORT useDialog, SHORT inpageRange, SHORT firstPage, SHORT lastPage, SHORT numCopies, SHORT inmode, SHORT tile, SHORT inScaleMode, SHORT inOrientation, IN_BOOL printBanner );
int API_EPOINT  IN_Refresh( IN_DOCWIN docwinID );
int API_EPOINT  IN_RegisterExternalDocumentWindow( HWND hWnd, IN_DOCWIN_PTR pDocwinID );
int API_EPOINT  IN_RelativeMeasure( IN_DOCWIN docwinID, SHORT action );
int API_EPOINT  IN_ResizePage( IN_DOCWIN docwinID, DOUBLE scale, DOUBLE aspect, IN_DOCWIN_PTR pDocwinID );
int API_EPOINT  IN_SaveSymbol( IN_DOCWIN docwinID, CHARPTR fileName, CHARPTR label );
int API_EPOINT  IN_SelectedSetCommand( IN_DOCWIN docwinID, SHORT command);
int API_EPOINT  IN_SetDocumentWindowRefresh( IN_DOCWIN docwinID, SHORT refreshFlag );
int API_EPOINT  IN_SetRelativeMeasureScale( IN_DOCWIN docwinID, SHORT units, long x1, long y1, long x2, long y2, DOUBLE length );
int API_EPOINT  IN_SetViewWindow( IN_DOCWIN docwinID, SHORT coordType, long x1, long y1, long x2, long y2 );
int API_EPOINT  IN_ShowDialog( IN_DOCWIN docwinID, SHORT dialogID );
int API_EPOINT  IN_ShowDocumentWindow( IN_DOCWIN docwinID, SHORT mode );
int API_EPOINT  IN_UnloadPages( IN_DOCWIN docwinID );
int API_EPOINT  IN_UnregisterExternalDocumentWindow( IN_DOCWIN docwinID );
int API_EPOINT  IN_CreatePreviewFile( IN_DOCWIN docwinID, USHORT xPels, USHORT yPels, IN_BOOL bColor, IN_BOOL bAsDisplayed, USHORT formatID, CHARPTR szFilename );



/* Document Operations */
int API_EPOINT  IN_DeleteObject( IN_OBJECT objectID );
int API_EPOINT  IN_GetNumberPages( IN_DOCWIN docwinID, SHORTPTR pPageCount );
int API_EPOINT  IN_GetPageID( IN_DOCWIN docwinID, SHORT pageNumber, IN_PAGE_PTR pPage );
int API_EPOINT  IN_GetPageIDs( IN_DOCWIN docwinID, SHORT maxPageIDs, SHORTPTR pPageCount, IN_PAGE_PTR pPageIDs );
int API_EPOINT  IN_GotoPage( IN_DOCWIN docwinID, SHORT pageNumber );
int API_EPOINT  IN_GotoPageID( IN_DOCWIN docwinID, IN_PAGE pageID );
int API_EPOINT  IN_GotoPageRelative( IN_DOCWIN docwinID, SHORT pageLoc );
int API_EPOINT  IN_ImportPage( IN_DOCWIN docwinID, SHORT pageNumber, SHORT relFlag, IN_OBJECT parentID, SHORT location, CHARPTR fileName, IN_PAGE_PTR pPageID );
int API_EPOINT  IN_NewPage( IN_DOCWIN docwinID, SHORT pageNumber, SHORT relFlag, IN_OBJECT parentID, SHORT pageType, IN_PAGE_PTR pPageID );
int API_EPOINT  IN_SaveObject( IN_DOCWIN docwinID, IN_OBJECT objectID, SHORT flags, CHARPTR filename, CHARPTR title, SHORT format );
int API_EPOINT  IN_NewView( IN_DOCWIN docwinID, SHORT viewType, IN_DOCWIN_PTR pNewDocwinID );



/* Page Operations */
int API_EPOINT  IN_GetActiveLayer( IN_DOCWIN docwinID, IN_PAGE pageID, IN_LAYER_PTR pActiveRaster, IN_LAYER_PTR pActiveLayer );
int API_EPOINT  IN_GetDisplayLayer( IN_DOCWIN docwinID, IN_LAYER layerID, IN_BOOLPTR pIsVisible );
int API_EPOINT  IN_GetLayerIDs( IN_PAGE pageID, SHORT maxLayerIDs, SHORTPTR pLayerCount, IN_LAYER_PTR pLayerIDs );
int API_EPOINT  IN_GetNumberLayers( IN_DOCWIN docwinID, IN_PAGE pageID, SHORTPTR pLayerCount );
int API_EPOINT  IN_GetPageNumber( IN_PAGE pageID, SHORTPTR pPage );
int API_EPOINT  IN_GetParentID( IN_OBJECT objID, IN_OBJECT_PTR pParentID);
int API_EPOINT  IN_ImportLayer( IN_PAGE pageID, SHORT location, CHARPTR filename, IN_LAYER_PTR pNewLayerID );
int API_EPOINT  IN_NewLayer( IN_PAGE pageID, SHORT layerType, IN_LAYER_PTR pNewLayerID );
int API_EPOINT  IN_ReorderPage( IN_PAGE pageID, SHORT pageNumber, SHORT relFlag, IN_OBJECT parentID );
int API_EPOINT  IN_SetActiveLayer( IN_DOCWIN docwinID, IN_LAYER layerID, IN_BOOL isActive );
int API_EPOINT  IN_SetDisplayLayer( IN_DOCWIN docwinID, IN_LAYER layerID, IN_BOOL isVisible );
int API_EPOINT  IN_UnloadPage( IN_PAGE pageID );
int API_EPOINT  IN_GetVisiblePageArea( IN_DOCWIN docwinID, IN_PAGE pageID, SHORTPTR units, LONGPTR x1, LONGPTR y1, LONGPTR x2, LONGPTR y2 );



/* Layer Operations */
int API_EPOINT  IN_ReorderLayers( IN_LAYER layerID, SHORT layerPosition );
int API_EPOINT  IN_ActivateAllHotspots( IN_DOCWIN docwinID, IN_LAYER layerID );
int API_EPOINT  IN_ActivateHotspot( IN_DOCWIN docwinID, IN_LAYER layerID, CHARPTR hotspotID );
int API_EPOINT  IN_DeleteHotspot( IN_LAYER layerID, CHARPTR hotspotID );
int API_EPOINT  IN_PlaceHotspot( IN_DOCWIN docwinID, SHORT objectType, CHARPTR pHotspotID, SHORT unitType, long p1, long p2, long p3, long p4 );
int API_EPOINT  IN_PlaceSymbol( IN_DOCWIN docwinID, SHORT unitType, long xLocation, long yLocation );
int API_EPOINT  IN_PlaceText( IN_DOCWIN docwinID, SHORT unitType, long x, long y, CHARPTR pText, long color, SHORT typeFace, DOUBLE size, SHORT sizeUnits, CHARPTR fontName, SHORT angle);
int API_EPOINT  IN_SetHotspotData( IN_LAYER layerID, CHARPTR hotspotID, CHARPTR newData );
int API_EPOINT  IN_SetHotspotIcon( IN_LAYER layerID, CHARPTR hotspotID, SHORT newIconIndex );
int API_EPOINT  IN_SetHotspotID( IN_LAYER layerID, CHARPTR hotspotID, CHARPTR newID );
int API_EPOINT  IN_GetObjectAttribute( IN_LAYER layerID, long objectID, SHORT attributeID, SHORT valueLen, CHARPTR value );
int API_EPOINT  IN_SetObjectAttribute( IN_LAYER layerID, long objectID, SHORT attributeID, CHARPTR value, USHORT units );
int API_EPOINT  IN_GetLayerToolAttribute( IN_LAYER layerID, SHORT toolID, SHORT attributeID, SHORT valueLen, CHARPTR value );
int API_EPOINT  IN_SetLayerToolAttribute( IN_LAYER layerID, SHORT toolID, SHORT attributeID, CHARPTR value, USHORT units );
int API_EPOINT  IN_ExtractText( IN_LAYER layerID, CHARPTR fileName, ULONG options, ULONGPTR count );
int API_EPOINT  IN_TextSearch( IN_DOCWIN docwinID, IN_LAYER layerID, long searchType, CHARPTR searchString, long occurrence, USHORT matchStringLen, LONGPTR matchCount, SHORTPTR objectType, LONGPTR x1, LONGPTR y1, LONGPTR x2, LONGPTR y2, CHARPTR matchString );
int API_EPOINT  IN_TextReplace( IN_DOCWIN docwinID, IN_LAYER layerID, long searchType, CHARPTR searchString, CHARPTR replaceString, long occurrence, LONGPTR matchCount );
int API_EPOINT  IN_CropLayer( IN_DOCWIN docwinID, IN_PAGE pageID, IN_LAYER layerID, SHORT predefinedSize, SHORT coordSystem, long x1, long y1, long x2, long y2, IN_DOCWIN_PTR pNewDocwinID );
int API_EPOINT  IN_ChangeRaster( IN_DOCWIN docwinID, IN_PAGE pageID, SHORT xResolution, SHORT yResolution, SHORT rotation, SHORT mirror, SHORT negative, IN_DOCWIN_PTR pNewDocwinID );
int API_EPOINT  IN_GetLayerInfo( IN_DOCWIN docwinID, IN_LAYER layerID, IN_LAYER_INFO_PTR pLayerInfo );
int API_EPOINT  IN_GetHotspotBLOB( IN_LAYER layerID, CHARPTR hotspotID, USHORT maxLen, USHORTPTR pBLOBLen, STDPTR pBLOB );
int API_EPOINT  IN_PlaceHotspotBLOB( IN_LAYER layerID, USHORT blobLen, STDPTR pBLOB );
int API_EPOINT  IN_MoveLayer( IN_LAYER layerID, IN_LAYER relLayerID, USHORT units, LONG x1, LONG y1, LONG x2, LONG y2 );

int API_EPOINT  IN_GetFirstVectorObjectID( IN_LAYER layerID, IN_VECTOR_PTR pVectorID );
int API_EPOINT  IN_GetNextVectorObjectID( IN_LAYER layerID, IN_VECTOR vectorID, IN_VECTOR_PTR pNextVectorID );
int API_EPOINT  IN_GetVectorObjectDescription( IN_LAYER layerID, IN_VECTOR vectorID, USHORT maxDescSize, STDPTR pObjectDesc, USHORTPTR pDescSize );
int API_EPOINT  IN_GetVectorObjectDescSize( IN_LAYER layerID, IN_VECTOR vectorID, USHORTPTR pDescSize );
int API_EPOINT  IN_PlaceVectorObject( IN_LAYER layerID, STDPTR pObjectDesc, USHORT descSize );
int API_EPOINT  IN_GetVectorObjectCount( IN_LAYER layerID, ULONGPTR pCount );



/* Scan Operations */
int API_EPOINT  IN_StartScan( IN_DOCWIN docwinID );
int API_EPOINT  IN_StopScan( void );


/* User Attribute Options */
int API_EPOINT  IN_DeleteUserAttribute( IN_OBJECT objID, CHARPTR attrID );
int API_EPOINT  IN_SetUserAttribute( IN_OBJECT objID, CHARPTR attrID, SHORT dataSize, CHARPTR attrData );
int API_EPOINT  IN_GetUserAttribute( IN_OBJECT objID, CHARPTR attrID, SHORT maxSize, CHARPTR attrData );

#endif


/* IN_API.H */
/* end of file */


